% Rotation of surfaces Alpha-tensor
ad11 = sym('ad11', 'real');
ad22 = sym('ad22', 'real');
ad33 = sym('ad33', 'real');
ad12 = sym('ad12', 'real');
ad23 = sym('ad23', 'real');
ad13 = sym('ad13', 'real');

ad110 = sym('ad110', 'real');
ad220 = sym('ad220', 'real');
ad330 = sym('ad330', 'real');
ad120 = sym('ad120', 'real');
ad230 = sym('ad230', 'real');
ad130 = sym('ad130', 'real');

% Rotation of surfaces Beta-tensor
bd11 = sym('bd11', 'real');
bd22 = sym('bd22', 'real');
bd33 = sym('bd33', 'real');
bd12 = sym('bd12', 'real');
bd23 = sym('bd23', 'real');
bd13 = sym('bd13', 'real');

bd110 = sym('bd110', 'real');
bd220 = sym('bd220', 'real');
bd330 = sym('bd330', 'real');
bd120 = sym('bd120', 'real');
bd230 = sym('bd230', 'real');
bd130 = sym('bd130', 'real');

% Vectors
ad   = [ad11 ; ad22 ; ad33 ; ad12 ; ad23 ; ad13 ];
ad0  = [ad110; ad220; ad330; ad120; ad230; ad130];
bd   = [bd11 ; bd22 ; bd33 ; bd12 ; bd23 ; bd13 ];
bd0  = [bd110; bd220; bd330; bd120; bd230; bd130];

% Deviatoric vector
bdd  = bd;
bdd(4:6) = sqrt(2)*bd(4:6);

add  = ad;
add(4:6) = sqrt(2)*add(4:6);

% Invariants - Alpha-tensor
sda        = s - ad*p;
smatrixa   = tomatrix(sda);
J2a        = 1/2*trace(smatrixa^2);
J3a        = 1/3*trace(smatrixa^3);
sin3tetaa  = -3*sqrt(3)*J3a/2/(J2a)^(3/2);

sd0a       = s0 - ad0*p0;
s0matrixa  = tomatrix(sd0a);
J20a       = 1/2*trace(s0matrixa^2);
J30a       = 1/3*trace(s0matrixa^3);
sin3teta0a = -3*sqrt(3)*J30a/2/(J20a)^(3/2);

% Invariants - Beta-tensor
sdb        = s - bd*p;
smatrixb   = tomatrix(sdb);
J2b        = 1/2*trace(smatrixb^2);
J3b        = 1/3*trace(smatrixb^3);
sin3tetab  = -3*sqrt(3)*J3b/2/(J2b)^(3/2);


sd0b       = s0 - bd0*p0;
s0matrixb  = tomatrix(sd0b);
J20b       = 1/2*trace(s0matrixb^2);
J30b       = 1/3*trace(s0matrixb^3);
sin3teta0b = -3*sqrt(3)*J30b/2/(J20b)^(3/2);