function out = newtonraphson(v00n, c, dEinc, dt, tol)
% Made 22.01.16 Jon A. Ronningen
% Newton-Raphson iteration

% Initial guess
vn = v00n;

% Initialization
res = 1/tol;
i = 0;

while (res > tol)
    JS  = jacobians(vn, v00n, c, dEinc);
    rn  = residuals(vn, v00n, c, dEinc);
    vn  = vn - JS\rn;
    res = rn'*rn;
    i = i + 1;
end

out = vn;

