#### Initiate connection ####

#Point to Plaxis folder
plaxis_path=r'C:\Program Files (x86)\Plaxis\PLAXIS 2D'

#Import modules/libraries
import imp                      # For Plaxis scripting
import numpy as np              # Math module for array
import matplotlib.pyplot as plt # Graph plotting

#Find and load  python scripts in plxscripting folder
found_module = imp.find_module('plxscripting', [plaxis_path])
plxscripting = imp.load_module('plxscripting',*found_module)
from plxscripting.easy import *

#Point to server and port
s_i, g_i = new_server('localhost',10000)
s_o, g_o = new_server('localhost',10001)


#  %%%%  s_i.new() #Creates new Plaxis model  %%%%
#s_i.new()


#Set soil geometry
boundary = g_i.SoilContour()
boundary.movepoint(0,
    0, 0)

#Create material
material = g_i.soilmat()
material.setproperties(
    "MaterialName", "Sand",
    "Colour", 15262369,
    "SoilModel", 3,
    "gammaUnsat", 17,
    "gammaSat", 20,
    "E50ref", 20000,
    "powerm", 0.5,
    "nu", 0.2,
    "cref", 0.1,
    "phi",39,
    "K0Determination", "Manual",
    "K0primary", 0.6,
    "K0nc", 0.371)


#Set drive specifications ???