# -*- coding: utf-8 -*-

### Boilerplate code ###
localhostport_input = 10000
#localhostport_output= 10001

# Libraries
from PyQt4 import QtCore, QtGui
import numpy as np
import sys, imp, subprocess

# Location of plaxis.exe folder
plaxis_path = r'C:\Program Files (x86)\Plaxis\PLAXIS 2D' #no trailing backslash!
# 
found_module = imp.find_module('plxscripting', [plaxis_path])
plxscripting = imp.load_module('plxscripting', *found_module)
from plxscripting.easy import *

# Input
# s - Store remote scripting server (PLAXIS Project Interface) as an object
# g - Global object (actual model)
s_i, g_i = new_server('localhost', localhostport_input)
#s_o, g_o = new_server('localhost', localhostport_output)

# Start Program
subprocess.Popen(['C:\\Program Files (x86)\\Plaxis\\PLAXIS 2D\\Plaxis2dXInput.exe', "--AppServerPort="+str(localhostport_input)])



### GUI code ###
try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)


class Ui_Form(object):
    def __init__(self):      

        s_i.new() # Create blank project
        

    def setupUi(self, Form):
        Form.setObjectName(_fromUtf8("Form"))
        Form.resize(240, 320)
        
        self.gridLayout_2 = QtGui.QGridLayout(Form)
        self.gridLayout_2.setObjectName(_fromUtf8("gridLayout_2"))
        self.gridLayout = QtGui.QGridLayout()
        self.gridLayout.setObjectName(_fromUtf8("gridLayout"))
        
        # Buttons!
        self.btn1 = QtGui.QPushButton(Form)
        self.btn1.setMinimumSize(QtCore.QSize(50, 50))
        self.btn1.setObjectName(_fromUtf8("New branch"))
        self.gridLayout.addWidget(self.btn1, 0, 0, 1, 1)
        self.btn1.clicked.connect(self.next_Phase)
        
        self.btn2 = QtGui.QPushButton(Form)
        self.btn2.setMinimumSize(QtCore.QSize(50, 50))
        self.btn2.setObjectName(_fromUtf8("New calc"))
        self.gridLayout.addWidget(self.btn2, 0, 1, 1, 1)
        self.btn2.clicked.connect(self.new_Calc)
        
        self.btn3 = QtGui.QPushButton(Form)
        self.btn3.setMinimumSize(QtCore.QSize(50, 50))
        self.btn3.setObjectName(_fromUtf8("Change Material"))
        self.gridLayout.addWidget(self.btn3, 1, 0, 1, 1)
        self.btn3.clicked.connect(self.change_Material)
        
        self.btn4 = QtGui.QPushButton(Form)
        self.btn4.setMinimumSize(QtCore.QSize(50, 50))
        self.btn4.setObjectName(_fromUtf8("Add next phase"))
        self.gridLayout.addWidget(self.btn4, 1, 1, 1, 1)
        self.btn4.clicked.connect(self.add_Next_Phase)
        
        self.btn5 = QtGui.QPushButton(Form)
        self.btn5.setMinimumSize(QtCore.QSize(50, 50))
        self.btn5.setObjectName(_fromUtf8("Undo"))
        self.gridLayout.addWidget(self.btn5, 2, 0, 1, 1)
        self.btn5.clicked.connect(self.undo_Method)
        
        self.btn6 = QtGui.QPushButton(Form)
        self.btn6.setMinimumSize(QtCore.QSize(50, 50))
        self.btn6.setObjectName(_fromUtf8("GBS Model"))
        self.gridLayout.addWidget(self.btn6, 2, 1, 1, 1)
        self.btn6.clicked.connect(self.Create_GBS_Model)
        
        self.btn7 = QtGui.QPushButton(Form)
        self.btn7.setMinimumSize(QtCore.QSize(50, 50))
        self.btn7.setObjectName(_fromUtf8("btn7"))
        self.gridLayout.addWidget(self.btn7, 3, 0, 1, 1)
        
        self.btn8 = QtGui.QPushButton(Form)
        self.btn8.setMinimumSize(QtCore.QSize(50, 50))
        self.btn8.setObjectName(_fromUtf8("btn8"))
        self.gridLayout.addWidget(self.btn8, 3, 1, 1, 1)
        
        self.btn9 = QtGui.QPushButton(Form)
        self.btn9.setMinimumSize(QtCore.QSize(50, 50))
        self.btn9.setObjectName(_fromUtf8("btn9"))
        self.gridLayout.addWidget(self.btn9, 4, 0, 1, 1)
        
        self.btn10 = QtGui.QPushButton(Form)
        self.btn10.setMinimumSize(QtCore.QSize(50, 50))
        self.btn10.setObjectName(_fromUtf8("btn10"))
        self.gridLayout.addWidget(self.btn10, 4, 1, 1, 1)
        
        self.gridLayout_2.addLayout(self.gridLayout, 0, 0, 1, 1)

        self.retranslateUi(Form)
        QtCore.QMetaObject.connectSlotsByName(Form)
        

    def retranslateUi(self, Form):
        Form.setWindowTitle(_translate("Form", "Form", None))
        self.btn1.setText(_translate("Form", "New branch", None))
        self.btn2.setText(_translate("Form", "New Calc", None))
        self.btn3.setText(_translate("Form", "Change Material", None))
        self.btn4.setText(_translate("Form", "Add next phase", None))
        self.btn5.setText(_translate("Form", "Undo", None))
        self.btn6.setText(_translate("Form", "GBS Model", None))
        self.btn7.setText(_translate("Form", "7", None))
        self.btn8.setText(_translate("Form", "8", None))
        self.btn9.setText(_translate("Form", "9", None))
        self.btn10.setText(_translate("Form", "10", None))
    
    def next_Phase(self):
        #value = g_i.Phases[:]
        #print(value.Name.Value)
        
        lastphase = g_i.Phase_1
        lastphase = g_i.phase(lastphase)
    
    def new_Calc(self):
        var = g_i.echo(g_i.Phase_1.ShouldCalculate)
        
        var = str(var[25:30])
        
        if var == 'False':
            g_i.Phase_1.ShouldCalculate.set(True)
        else:
            g_i.Phase_1.ShouldCalculate.set(False)
     
    def change_Material(self):
        var = g_i.echo(g_i.Soil_1_2.Material)
        var = var[139:len(var)]
        
        if var == 'Loam2':
            g_i.setmaterial(g_i.Soil_1_2, g_i.Phase_1, g_i.Loam)
        else:
            g_i.setmaterial(g_i.Soil_1_2, g_i.Phase_1, g_i.Loam2)
    
    def add_Next_Phase(self):
        # Add 2 phases from last phase
        var = g_i.echo(g_i.phases)
        var = var[(len(var)-10):(len(var)-3)]
        
        if var == 'Phase_6':
            lastphase = g_i.phase(g_i.Phase_6)
        elif var == 'Phase_7':
            lastphase = g_i.phase(g_i.Phase_7)
        
        ## Add n phases from Phase 1
        # lastphase = g_i.Phase_1
        # x=1
        # while x < 4000: #User stop at ~4000 phases
        #     lastphase = g_i.phase(lastphase)
        #     x = x + 1
        
    # def get_NumberOfPhases(self):
    #     text, ok = QInputDialog.getText(self, 'Number of phases', 'How many phases do you want to add?'
    #     #print(text,ok)
    #     #return text

    def undo_Method(self):
        g_i.undo()
        
    
    def Create_GBS_Model(self):
        g_i.clear()
        g_i.SoilContour.initializerectangular(0, -0.2, 1, 0) # Set size of model
        g_i.setproperties("Title","GBS-Model",
"Comments","",
"UnitForce","kN",
"UnitLength","m",
"UnitTime","day",
"UnitTemperature","K",
"UnitEnergy","kJ",
"UnitPower","kW",
"WaterWeight",10,
"ReferenceTemperature",293.15,
"LiquidSpecificHeatCapacity",4181.3,
"LiquidThermalConductivity",0.0006,
"LiquidLatentHeat",334000,
"LiquidThermalExpansion",0.00021,
"LiquidTemperature",293.15,
"IceSpecificHeatCapacity",2108,
"IceThermalConductivity",0.00222,
"IceThermalExpansion",5E-5,
"VapourSpecificHeatCapacity",1930,
"VapourThermalConductivity",2.5E-5,
"VapourSpecificGasConstant",461.5,
"UseTemperatureDepWaterPropsTable",False,
"ModelType","Plane-strain",
"ElementType","15-Noded")
        g_i.borehole(0) # Define borehole in point x
        g_i.soillayer(0) # Define layer in height y
        g_i.setsoillayerlevel(g_i.Borehole_1, 1, -0.2) # Adjust soil layer size
        material = g_i.soilmat() # Add SoilMat_1
        g_i.set(g_i.Soillayer_1.Soil.Material, g_i.SoilMat_1) # Assign material to layer
        g_i.sps(g_i.SoilMat_1, "MaterialName", 'Soil 1', "Gref", 1000, "nu", 0.3, "cref", 50, "DrainageType", 3)
        
        
        # Define structure
        structurePosX = [0.327, 0.673]
        structurePosY = [-0.095, 0, 0.4]
        for i in structurePosX:
            for k in structurePosY:
                g_i.point(i,k)
        g_i.point((structurePosX[0]+structurePosX[1])/2,structurePosY[2])
        
        g_i.line(g_i.Point_1, g_i.Point_2, g_i.Point_3)
        g_i.line(g_i.Point_4, g_i.Point_5, g_i.Point_6)
        g_i.line(g_i.Point_1, g_i.Point_4)
        g_i.line(g_i.Point_3, g_i.Point_7, g_i.Point_6)
        
        # Load on structure
        g_i.lineload(g_i.Line_5)
        g_i.pointload(g_i.Point_7)
        
        g_i.set(g_i.Line_5.LineLoad.q_start, 22.44)
        
        g_i.set(g_i.Point_7.PointLoad.Fy, 0)
        g_i.set(g_i.Point_7.PointLoad.Fx, 1) 
        
        # Define framework
        g_i.plate(g_i.Line_1, g_i.Line_2, g_i.Line_3, g_i.Line_4, g_i.Line_5, g_i.Line_6, g_i.Line_7)
        
        plateMaterial = [("MaterialName","PlateO"),("EA",1),("EI",1),("nu",0),("d",3.46410161513775),("w",0),("Gref",0.144337567297406)]
        g_i.platemat()
        g_i.set([g_i.Line_1.Plate.Material, g_i.Line_2.Plate.Material, g_i.Line_3.Plate.Material, g_i.Line_4.Plate.Material, g_i.Line_5.Plate.Material, g_i.Line_6.Plate.Material, g_i.Line_7.Plate.Material],  g_i.PlateMat2D_1)
        g_i.sps(g_i.PlateMat2D_1, *plateMaterial)
        
        #g_i.sps(g_i.PlateMat2D_1,  */Must reduce number of args/* )
        
        g_i.posinterface(g_i.Line_1)
        g_i.neginterface( g_i.Line_5, g_i.Line_3)
        
        # Meshing
        g_i.mergeequivalents(g_i.Geometry)
        g_i.gotomesh()
        g_i.mesh(0.06)
        
        # Phases
        g_i.gotostages()
        Phase_1 = g_i.phase(g_i.phases[0]) # New phase
        g_i.activate([g_i.Line_1_1, g_i.Line_2_1, g_i.Line_3_1, g_i.Line_4_1, g_i.Line_5_1, g_i.Line_6_1, g_i.Line_7_1 ], Phase_1)
        
        Phase_2 = g_i.phase(g_i.phases[1])
        g_i.deactivate(g_i.BoreholePolygon_1_1, Phase_2) 
        
        
        # Calculation
        g_i.calculate()
        
        

    
if __name__ == "__main__":
    import sys
    app = QtGui.QApplication(sys.argv)
    Form = QtGui.QWidget()
    ui = Ui_Form()
    ui.setupUi(Form)
    Form.show()
    sys.exit(app.exec_())