localhostport_output = 10001
plaxis_path = r'C:\Program Files (x86)\Plaxis\PLAXIS 2D' #no trailing backslash!

import imp
found_module = imp.find_module('plxscripting', [plaxis_path])
plxscripting = imp.load_module('plxscripting', *found_module)
from plxscripting.easy import *

s_o, g_o = new_server('localhost', localhostport_output)


#geometric data for correct anchor:
Xanchor = 60.0
Yanchor = 27.0

#start from Phase_3 since the anchors are not active before this phase
for phase in g_o.Phases[3:]:
    anchorF = g_o.getresults(phase, g_o.ResultTypes.NodeToNodeAnchor.AnchorForce2D, 'node')
    anchorX = g_o.getresults(phase, g_o.ResultTypes.NodeToNodeAnchor.X, 'node')
    anchorY = g_o.getresults(phase, g_o.ResultTypes.NodeToNodeAnchor.Y, 'node')

    for x,y,N in zip(anchorX,anchorY,anchorF):
        #check for the correct anchor by location:
        if abs(x - Xanchor) < 1E-5 and abs(y - Yanchor) < 1E-5:
            print("Anchor force N in {}: {:.2f} kN/m".format(phase.Name,N))