localhostport_output = 10001
plaxis_path = r'C:\Program Files (x86)\Plaxis\PLAXIS 2D' #no trailing backslash!

import imp
found_module = imp.find_module('plxscripting', [plaxis_path])
plxscripting = imp.load_module('plxscripting', *found_module)
from plxscripting.easy import *

s_o, g_o = new_server('localhost', localhostport_output)

#geometric limits for the bottom of the excavation:
x_left = 40.0
x_right = 60.0
y_bottom = 20.0

#initialize defaults
maxUy = 0.0
xAtMaxUy = 0.0
yAtMaxUy = 0.0

#obtain result tables from Output:
soilX = g_o.getresults(g_o.Phase_6, g_o.ResultTypes.Soil.X, 'node')
soilY = g_o.getresults(g_o.Phase_6, g_o.ResultTypes.Soil.Y, 'node')
soilUy = g_o.getresults(g_o.Phase_6, g_o.ResultTypes.Soil.Uy, 'node')

#determine maximum heave
for x, y, uy in zip(soilX, soilY, soilUy):
    if x_left < x < x_right:
        if abs(y - y_bottom) < 1E-5:
            if uy > maxUy:
                maxUy = uy
                xAtMaxUy = x
                yAtMaxUy = y

print("Maximum heave of excavation bottom: uy={:.3f} m "
    "at (X,Y)=({:.2f},{:.2f})".format(maxUy, xAtMaxUy, yAtMaxUy))