# import numpy as np
# import matplotlib.pyplot as plt
# from matplotlib.widgets import Slider, Button, RadioButtons
# 
# fig, ax = plt.subplots()
# plt.subplots_adjust(left=0.25, bottom=0.25)
# t = np.arange(0.0, 1.0, 0.001)
# a0 = 5
# f0 = 3
# s = a0*np.sin(2*np.pi*f0*t)
# l, = plt.plot(t, s, lw=2, color='red')
# plt.axis([0, 1, -10, 10])
# 
# axcolor = 'lightgoldenrodyellow'
# axfreq = plt.axes([0.25, 0.1, 0.65, 0.03], facecolor=axcolor)
# axamp = plt.axes([0.25, 0.15, 0.65, 0.03], facecolor=axcolor)
# 
# sfreq = Slider(axfreq, 'Freq', 0.1, 30.0, valinit=f0)
# samp = Slider(axamp, 'Amp', 0.1, 10.0, valinit=a0)
# 
# 
# def update(val):
#     amp = samp.val
#     freq = sfreq.val
#     l.set_ydata(amp*np.sin(2*np.pi*freq*t))
#     fig.canvas.draw_idle()
# sfreq.on_changed(update)
# samp.on_changed(update)
# 
# resetax = plt.axes([0.8, 0.025, 0.1, 0.04])
# button = Button(resetax, 'Reset', color=axcolor, hovercolor='0.975')
# 
# 
# def reset(event):
#     sfreq.reset()
#     samp.reset()
# button.on_clicked(reset)
# 
# rax = plt.axes([0.025, 0.5, 0.15, 0.15], facecolor=axcolor)
# radio = RadioButtons(rax, ('red', 'blue', 'green'), active=0)
# 
# 
# def colorfunc(label):
#     l.set_color(label)
#     fig.canvas.draw_idle()
# radio.on_clicked(colorfunc)
# 
# plt.show()

# import numpy
# import matplotlib.pyplot as plt
# from matplotlib.widgets import Slider
# # fake data
# xdata = numpy.random.rand(100,100) 
# ydata = numpy.random.rand(100,100) 
# # set up figure
# fig = plt.figure()
# ax = fig.add_subplot(111)
# ax.autoscale(True)
# plt.subplots_adjust(left=0.25, bottom=0.25)
# 
# # plot first data set
# frame = 0
# ln, = ax.plot(xdata[frame],ydata[frame])
# 
# # make the slider
# axframe = plt.axes([0.25, 0.1, 0.65, 0.03])
# sframe = Slider(axframe, 'Frame', 0, 99, valinit=0,valfmt='%d')
# 
# # call back function
# def update(val):
#     frame = numpy.floor(sframe.val)
#     ln.set_xdata(xdata[frame])
#     ln.set_ydata((frame+1)* ydata[frame])
#     ax.set_title(frame)
#     ax.relim()
#     ax.autoscale_view()
#     plt.draw()
# 
# # connect callback to slider   
# sframe.on_changed(update)
# plt.show()

from PyQt4 import QtGui
import matplotlib.pyplot as plt
from matplotlib.backends.backend_qt4agg import FigureCanvasQTAgg as FigureCanvas
from matplotlib.backends.backend_qt4agg import NavigationToolbar2QT as NavigationToolbar

class ScrollableWindow(QtGui.QMainWindow):
    def __init__(self, fig):
        self.qapp = QtGui.QApplication([])

        QtGui.QMainWindow.__init__(self)
        self.widget = QtGui.QWidget()
        self.setCentralWidget(self.widget)
        self.widget.setLayout(QtGui.QVBoxLayout())
        self.widget.layout().setContentsMargins(0,0,0,0)
        self.widget.layout().setSpacing(0)

        self.fig = fig
        self.canvas = FigureCanvas(self.fig)
        self.canvas.draw()
        self.scroll = QtGui.QScrollArea(self.widget)
        self.scroll.setWidget(self.canvas)

        #self.nav = NavigationToolbar(self.canvas, self.widget)
        #self.widget.layout().addWidget(self.nav)
        self.widget.layout().addWidget(self.scroll)

        self.show()
        #exit(self.qapp.exec_()) 


# create a figure and some subplots
fig, axes = plt.subplots(ncols=10, nrows=1)
for ax in axes.flatten():
    ax.plot([2,3,5,1])


# pass the figure to the custom window  
if __name__ == "__main__":
    import sys
    from PyQt4 import QtGui
    import numpy as np
    
    app = QtGui.QApplication(sys.argv)
    main = ScrollableWindow(fig)
    main.show()
    sys.exit(app.exec_())
# 
# from matplotlib.pyplot import figure, show
# import numpy as npy
# from numpy.random import rand
# 
# 
# if 1: # picking on a scatter plot (matplotlib.collections.RegularPolyCollection)
# 
#     x, y, c, s = rand(4, 100)
#     def onpick3(event):
#         ind = event.ind
#         print('onpick3 scatter:', ind, npy.take(x, ind), npy.take(y, ind))
# 
#     fig = figure()
#     ax1 = fig.add_subplot(111)
#     col = ax1.scatter(x, y, 100*s, c, picker=True)
#     #fig.savefig('pscoll.eps')
#     fig.canvas.mpl_connect('pick_event', onpick3)
# 
# show()