localhostport_input = 10000

import imp, subprocess

# Location of plaxis.exe folder
plaxis_path = r'C:\Program Files (x86)\Plaxis\PLAXIS 2D' #no trailing backslash!

found_module = imp.find_module('plxscripting', [plaxis_path])
plxscripting = imp.load_module('plxscripting', *found_module)
from plxscripting.easy import *

# Input
# s - Store remote scripting server (PLAXIS Project Interface) as an object
# g - Global object (actual model)
s, g = new_server('localhost', localhostport_input)
#s_o, g_o = new_server('localhost', localhostport_output)

# Start Program
subprocess.Popen(['C:\\Program Files (x86)\\Plaxis\\PLAXIS 2D\\Plaxis2dXInput.exe', "--AppServerPort="+str(localhostport_input)])
#subprocess.Popen(['C:\\Program Files (x86)\\Plaxis\\PLAXIS 2D\\Plaxis2dXInput.exe', "--AppServerPort="+str(localhostport_input), "--NO_CONTROLLERS"]) - Start silent
s.new()

g.SoilContour.initializerectangular(0,0,10,10)
g.borehole(0)
g.soillayer(10)

material = g.soilmat()
material.setproperties("SoilModel", 1,"gammaUnsat", 16, "gammaSat", 20, "Gref", 10000)
g.Soils[0].Material = material

g.gotostructures()
g.lineload((3,0), (7,0))

# Added feature - creating an array, storing the results and performing actions on the diagonal
point = g.point(2.5,-7.5)
added_points = g.arrayr(point, 6, (1,0), 6, (0,1))
diagonal_points = []
for p in added_points:
    if abs(p.x+p.y) < 1E-4:
        diagonal_points.append(p)
        
g.pointload(diagonal_points)


g.gotomesh()
g.mesh(0.2)
output_port = g.selectmeshpoints()
s_output, g_output = new_server('localhost', output_port)
g_output.addcurvepoint('node', g_output.Soil_1_1, (5, 0))
g_output.update()

g.gotostages()
phase1 = g.phase(g.Phases[0])
g.LineLoads[0].Active[phase1] = True
g.calculate()

output_port = g.view(phase1)
s_output, g_output = new_server('localhost', output_port)
g_output.Curvepoints.Nodes[0]

utot = g_output.getcurveresults(g_output.CurvePoints.Nodes.value[0], g_output.Phases[1], g_output.Soil.Utot)


print(utot)

g.save(r'C:\Users\johannom\OneDrive - NTNU\3-Programming\Python\Plaxis\test')
