import sys, os
import numpy as np
from matplotlib import pyplot

from bearingCap import BearingCap, run
from elemTriaxialTest import ElemTriaxialTest

class testUSR(BearingCap):
    def apply_soil_material(self):
        """
        User Defined Material
        """
        MATERIAL_PARAMETERS = [
        ('MaterialName', 'Userdefined Material'),
        ('Colour', 10676870),
        ('SoilModel', 100), # Userdefined
        ('DrainageType', 'UndrainedA'),
        ('gammaUnsat', 20),
        ('gammaSat', 20),
        ("InterfaceStrength", 1),
        ("Gref", 1),
        ("cref", 1),        
        ('UserDLLName', 'usrmod.dll'),
        ('UserModel', "Geofuture soft clay model"),        
        ('User1',50),
        ('User2',20),
        ('User3',100),
        ('User4',500),
        ('User5',0.5),
        ('User6',0.35),
        ('User7',0.4),
        ('User8',0.1),
        ('User9',28),
        ('User10',0.7),
        ('User11',1.2),
        ('User12',2.3),
        ("K0PrimaryIsK0Secondary", True),
        ("K0Determination", 0),
        ("K0", 0.6)]

        soilMaterial = self.model.soilmat(*MATERIAL_PARAMETERS)
    
        for soil_layer in self.model.SoilLayers:
            self.model.setmaterial(soil_layer, soilMaterial)

if __name__ == '__main__':
    run(testUSR)

    